Nebulae_Marimba_V1.1.csd 
for the Qu-Bit Electronix Nebulae Eurorack module
www.qubitelectronix.com

Marimba is a marimba physical model oscillator

May 7, 2015

Collin Russell
collinrussellmusic.com
collinrussell0912@gmail.com

Andrew Ikenberry
andrewikenberry.com 
andrewikenberry@gmail.com

<CsoundSynthesizer>
<CsOptions>

-odac
--sched
-d
-+rtaudio=alsa
-Ma
-b512
-B1024
-m 0

</CsOptions>
<CsInstruments>

sr	=	22050	
ksmps	=	512
nchnls	=	1
0dbfs	=	1

prealloc 2, 12

gkinstances = 0

instr 1	

	ksystem system 1, "umount /dev/sda1 " ; unmounts flash drive
	ksystem system 1, "/home/scripts/fileLoadFeedback" ; tells arduino .csd loaded (This MUST be called)
	ksystem system 1, "/home/scripts/state_change pause" 
	ksystem system 1, "/home/scripts/state_change loop" 
	
	kutility ctrl7 1, 23, 0, 127

  	if (kutility == 23) then
    		ksystem system 1, "echo 3 > /var/tmp/start_flag"
    		event "e", 0, 0, 0
	endif
	
	; go to next .csd
	if (kutility == 24) then
    		ksystem system 1, "echo 1 > /var/tmp/start_flag"
    		event "e", 0, 0, 0
	endif

		krecall init 0
	; recall
	if (kutility == 12 && krecall == 0) then ; turn recall on
		krecall = 1
	elseif (kutility == 13) then ; turn recall off
		krecall = 0
	endif

	kactive active 2
	if (kactive >=10) then
		turnoff2 2, 1, 0.1
	endif

	ktrig	trigger	krecall,	0,	0.5
	if (krecall == 1) then
		schedkwhen	ktrig, 0.005,	10,	2,	0,	12
		krecall = 0
		kutility = 0
		ktrig = 0
	endif
	
endin

instr 2
	
	; Pitch
	kpitch ctrl14 1, 15, 16, 6, 11

	; Make pitch 1V/Octave
	kpitch pow 2, kpitch
	
	; Vibrato Rate (Grain Rate)
	kvibf ctrl7 1, 5, 0, 11

	; Vibrato Amount (Grain Size)
	kvamp ctrl7 1, 4, 0, 1

	adel linseg 0, 2, 0.02, 2, 0	
	asig marimba, 0.5, kpitch, 0.1, 0.561, 1, kvibf, kvamp, 2, 0.6, 0.1, 0.1
	
	gkinstances  active 2
	
	
	if (gkinstances == 1) then
		
		out asig
		
	else 
	
		out asig * 0.7
		
	endif

endin

</CsInstruments>
<CsScore>


;Table 1 mounts the audio file into memory. 
;F#	LdTm	Size	GEN	File					SkipTime Format	Channel
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
f1 	0	2048	1	"marmstk1.wav"	0  	   0   	0


;Table 2 computes a sine wave for the vibrato
;F#	LdTm	Size	GEN	Val
;~~~~~~~~~~~~~~~~~~~~~~~~~
f2	0 	1024 10 	1

i1 0 $INF
 
</CsScore>
</CsoundSynthesizer>

<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>100</x>
 <y>100</y>
 <width>320</width>
 <height>240</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
</bsbPanel>
<bsbPresets>
</bsbPresets>
